{% extends "base-backend.html" %}
{% block content %}

<!-- form_configuration_page -->

<script src="{{ url_for('static', filename='vendor/easymde/easymde.min.js') }}"></script>
<script src="{{ url_for('static', filename='vendor/formBuilder/form-render.min.js') }}"></script>
<link rel="stylesheet" type="text/css" href="{{ url_for('static', filename='vendor/easymde/easymde.min.css') }}">
<link rel="stylesheet" type="text/css" href="{{ url_for('static', filename='vendor/font-awesome/font-awesome.min.css') }}">

{% with active_item="settings",
        sub_option=False %}
  {% include 'form/partials/form-context.html' %}
{% endwith %}

{% with modal_id="insert_introduction_text_image_modal",
        form_id="insert_introduction_text_image_form" %}
  {% include 'common/insert-image-modal.html' %}
{% endwith %}
{% with modal_id="insert_introduction_text_link_modal",
        form_id="insert_introduction_text_link_form" %}
  {% include 'common/insert-link-modal.html' %}
{% endwith %}
{% with modal_id="insert_after_submit_text_image_modal",
        form_id="insert_after_submit_text_image_form" %}
  {% include 'common/insert-image-modal.html' %}
{% endwith %}
{% with modal_id="insert_after_submit_text_link_modal",
        form_id="insert_after_submit_text_link_form" %}
  {% include 'common/insert-link-modal.html' %}
{% endwith %}

<div class="ds-narrow-container">

  <div class="grid ds-header-title-nested ds-no-border mt-2">
    <div class="g-col-12 d-flex align-items-center justify-content-flex-start">
      <h2>{{ _("Form configuration") }}</h2>
      {% if form.is_public() %}
      <span id="is_public_badge" class="badge rounded-pill bg-success">{{ _("Public") }}</span>
      {% else %}
      <span id="is_public_badge" class="badge rounded-pill bg-secondary">{{ _("Not public") }}</span>
      {% endif %}
    </div>
  </div>

  <!-- Introduction text -->
  <div class="grid mt-1">
    <div class="g-col-12">
      <div id="introduction_text" class="card">
        {% set hidden_content = form_user.ui_preferences.introduction_text is defined and not form_user.ui_preferences.introduction_text %}
        <div class="card-header d-flex align-items-center justify-content-between">
          <h2>
            {% if not hidden_content %}
            <a href="#" class="toggle-card" title="{{_('Hide')}}""><i data-feather="chevron-up" width="24" height="24" stroke-width="2" aria-hidden="true"></i></a>
            {% else %}
            <a href="#" class="toggle-card" title="{{_('Show')}}""><i data-feather="chevron-down" width="24" height="24" stroke-width="2" aria-hidden="true"></i></a>
            {% endif %}
            {{ _("Introduction text") }}
          </h2>
          <div>
            <button class="show-editor-btn btn btn-sm btn-outline-primary">{{ _("Edit") }}</button>
          </div>
        </div>
        <div class="toggled-content" {% if hidden_content %}style="display:none"{% endif %}>
          <div class="px-3 py-3">
            {{ _("Tell your users what this form is about.") }}
          </div>
          <div class="card-body pt-0 ds-silence-text">
            <div class="pt-3 html-display ds-marked-up">
              {{ form.introduction_text["html"] | safe }}
            </div>
            <div class="md-editor" style="display:none">
              <div class="">
                <input class="save-markdown-edition btn btn-primary btn-sm" type="button" value="{{ _('Save') }}" />
                <input class="cancel-markdown-edition btn btn-outline-secondary btn-sm" type="button" value="{{ _('Cancel') }}" />
                <p class="mt-2 mb-2">
                  {{ _("This is a Markdown editor, an easy way to write HTML.") }}
                  <span class="text-nowrap">
                    <a href="#" onclick="toggleInlineHelp('markdown.j2.md')">{{ _("Learn more") }}</a>
                  </span>
                </p>
              </div>
              <textarea id="introduction-mde">{{ form.introduction_text["markdown"] }}</textarea> <!-- keep textarea on one line -->
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- Form fields -->
  <div class="grid mt-4">
    <div class="g-col-12">
      <div id="form_preview" class="card">
        {% set hidden_content = form_user.ui_preferences.form_preview is defined and not form_user.ui_preferences.form_preview %}
        <div class="card-header d-flex align-items-center justify-content-between">
          <h2>
            {% if not hidden_content %}
            <a href="#" class="toggle-card" title="{{_('Hide')}}""><i data-feather="chevron-up" width="24" height="24" stroke-width="2" aria-hidden="true"></i></a>
            {% else %}
            <a href="#" class="toggle-card" title="{{_('Show')}}""><i data-feather="chevron-down" width="24" height="24" stroke-width="2" aria-hidden="true"></i></a>
            {% endif %}
            {{ _("Form fields") }}
          </h2>
          {% set disable_btn = "disabled" if form.edit_mode and form.edit_mode['editor_id'] != current_user.id else "" %}
          <a class="btn btn-sm btn-outline-primary {{disable_btn}}" href="{{url_for('form_bp.edit_form', form_id=form.id)}}">{{ _("Edit") }}</a>
        </div>
        <div class="toggled-content" {% if hidden_content %}style="display:none"{% endif %}>
          <div class="card-body">
            {% if not form.structure %}
              <p class="mb-0">{{ _("Add, remove and configure the form's fields.") }}</p>
            {% else %}
              <div class="liberaform">
              {% include 'form/partials/render-builder.html' %}
              </div>
            {% endif %}
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- Data consents -->
  {% include 'form/partials/data-consent.html' %}

  <!-- After replying -->
  <div class="grid mt-4">
    <div class="g-col-12">
      <div id="after_submit_text" class="card">
        {% set hidden_content = form_user.ui_preferences.after_submit_text is defined and not form_user.ui_preferences.after_submit_text %}
        <div class="card-header d-flex align-items-center justify-content-between">
          <h2>
            {% if not hidden_content %}
            <a href="#" class="toggle-card" title="{{_('Hide')}}""><i data-feather="chevron-up" width="24" height="24" stroke-width="2" aria-hidden="true"></i></a>
            {% else %}
            <a href="#" class="toggle-card" title="{{_('Show')}}""><i data-feather="chevron-down" width="24" height="24" stroke-width="2" aria-hidden="true"></i></a>
            {% endif %}
            {{ _("Thank you text") }}
          </h2>
          <div class="card-header-controls">
            <button class="btn btn btn-sm btn-outline-primary" onClick="location.href='{{url_for('form_bp.preview_thankyou', form_id=form.id)}}'">{{ _("Preview") }}</button>
            <button class="show-editor-btn btn btn-sm btn-outline-primary">{{ _("Edit") }}</button>
          </div>
        </div>
        <div class="toggled-content" {% if hidden_content %}style="display:none"{% endif %}>
          <div class="px-3 py-3">
            <p class="mb-0">{{ _("Say something to the users after they have submitted the form.") }}</p>
          </div>
          <div class="card-body pt-0 ds-silence-text">
            <div class="pt-3 html-display ds-marked-up">
              {{ form.get_after_submit_text_html() | safe }}
            </div>
            <div class="md-editor" style="display:none">
              <div class="mt-0 mb-3">
                <input class="save-markdown-edition btn btn-primary btn-sm" type="button" value="{{ _('Save') }}" />
                <input class="cancel-markdown-edition btn btn-outline-primary btn-sm" type="button" value="{{ _('Cancel') }}" />
              </div>
              <!-- keep textarea on one line -->
              <textarea id="after-submit-mde">{{ form.get_after_submit_text_markdown() }}</textarea>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>

<script>
const inline_help_file_name = "form.j2.md";

// introduction text editor
const intro_toolbar = [
    "bold",
    "italic",
    "heading",
    "|", // Separator
    "unordered-list",
    "ordered-list",
    "|", // Separator
    "quote",
    "|", // Separator
    {
      name: "custom",
      action: function customLink(editor){
        $('#insert_introduction_text_link_form')[0].reset();
        $('#insert_introduction_text_link_modal').modal('show');
      },
      className: "fa fa-link",
      title: "Link",
    },
    {
      name: "custom",
      action: function customImage(editor){
        $('#insert_introduction_text_image_form')[0].reset();
        $('#insert_introduction_text_image_modal').modal('show');
      },
      className: "fa fa-picture-o",
      title: "Image",
    },
    "|", // Separator
    "preview",
    "guide"
];
var introductionMDE = new EasyMDE({
                    toolbar: intro_toolbar,
                    autosave: {enabled: false},
                    autofocus: false,
                    spellChecker: false,
                    autoDownloadFontAwesome: false,
                    element: $("#introduction-mde")[0]
});
// after submit text editor
const aftersubmit_toolbar = [
    "bold",
    "italic",
    "heading",
    "|", // Separator
    "unordered-list",
    "ordered-list",
    "|", // Separator
    "quote",
    "|",
    {
      name: "custom",
      action: function customLink(editor){
        $('#insert_after_submit_text_link_form')[0].reset();
        $('#insert_after_submit_text_link_modal').modal('show');
      },
      className: "fa fa-link",
      title: "Link",
    },
    {
      name: "custom",
      action: function customImage(editor){
        $('#insert_after_submit_text_image_form')[0].reset();
        $('#insert_after_submit_text_image_modal').modal('show');
      },
      className: "fa fa-picture-o",
      title: "Image",
    },
    "|", // Separator
    "preview",
    "guide"
];
var afterSubmitMDE = new EasyMDE({
                            toolbar: aftersubmit_toolbar,
                            autosave: {enabled: false},
                            autofocus: true,
                            spellChecker: false,
                            autoDownloadFontAwesome: false,
                            element: document.getElementById("after-submit-mde")
                         });

$(document).ready(function() {

  {% include 'common/toggle_card.js' %}

  $(".show-editor-btn, .cancel-markdown-edition").click(function() {
    let card = $(this).closest('.card')
    if (!card.find('.toggled-content').is(':visible')) {
      _toggleCard(card)
    }
    toggleMarkdownEditor(card)
  })
  function toggleMarkdownEditor(card) {
    let card_name = card.prop('id')
    let is_html_visible = card.find('.html-display').is(':visible')

    if (is_html_visible) {
      card.find('.html-display').hide();
      card.find(".card-body").removeClass("ds-silence-text")
      card.find('.md-editor').show(0, function() {
        if (card_name == "introduction_text") {
          introductionMDE.codemirror.refresh();
        }
        if (card_name == "after_submit_text") {
          afterSubmitMDE.codemirror.refresh();
        }
      });
      card.find(".toggled-content").show()
      card.find(".saved-alert").remove()
      card.find(".card-header-controls").find('button').prop('disabled', true);
    } else {
      card.find('.md-editor').hide()
      card.find('.html-display').show()
      card.find(".card-body").addClass("ds-silence-text")
      card.find(".card-header-controls").find('button').prop('disabled', false)
      if (card_name == "introduction_text") {
        introductionMDE.value($("#introduction-mde").val())
      }
      if (card_name == "after_submit_text") {
        afterSubmitMDE.value($("#after-submit-mde").val())
      }
    }
  }
  $(".save-markdown-edition").click(function(){
    let card = $(this).closest('.card')
    let card_name = card.prop('id')
    if (card_name == "introduction_text") {
      var save_url = "{{ url_for('form_bp.save_introduction_text', form_id=form.id)}}"
      var markdown = introductionMDE.value()
    }
    if (card_name == "after_submit_text") {
      var save_url = "{{ url_for('form_bp.save_after_submit_text', form_id=form.id)}}"
      var markdown = afterSubmitMDE.value()
    }
    $.ajax({
      url : save_url,
      type: "POST",
      dataType: "json",
      data: {"markdown": markdown},
      beforeSend: function(xhr, settings) {
        if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
          xhr.setRequestHeader("X-CSRFToken", csrftoken)
        }
      },
      success: function(data, textStatus, jqXHR)
      {
        card.find(".card-header-controls").find('button').prop('disabled', false);
        card.find(".html-display").html(data.html)
        card.find(".card-body").addClass("ds-silence-text")
        card.find(".md-editor").hide()
        card.find(".html-display").show(0)
        card.find(".card-header-controls").prepend(saved_alert)

        if (card_name == "introduction_text") {
          $("#introduction-mde").val(data.markdown)
          introductionMDE.value($("#introduction-mde").val())
        }
        if (card_name == "after_submit_text") {
          $("#after-submit-mde").val(data.markdown)
          afterSubmitMDE.value($("#after-submit-mde").val())
        }
      }
    });
  });
});

{% if goto %}
$(document).ready(function() {
  if ("{{goto}}" == "introduction-text") {
    $("#introduction_text").find(".show-editor-btn").trigger("click")
  }
  if ("{{goto}}" == "thank-you-text") {
    $("#after_submit_text").find(".show-editor-btn").trigger("click")
    $('html, body').animate({scrollTop: $('#after_submit_text').offset().top + (-81)}, "slow");
  }
  if ("{{goto}}" == "privacy-statements") {
    if ($("#data_consents").find(".card-body").is(":visible") == false) {
      $("#data_consents").find(".toggle-card").trigger("click")
    }
    $('html, body').animate({scrollTop: $('#data_consents').offset().top + (-81)}, "slow");
  }
})
{% endif %}

const saved_alert = `
<span type="button" class="saved-alert btn btn-sm btn-success" aria-label="{{ _('Saved') }}" style="cursor:initial;">
  <svg xmlns="http://www.w3.org/2000/svg" width="18" height="18" viewBox="0 0 24 24" fill="none" stroke="#fff" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-check"><polyline points="20 6 9 17 4 12"></polyline></svg>
</span>
`

$(document).ready(function() {
  $(document).on("insert_image", function(event, form_id) {
    $('.modal').modal('hide');
    var image_url = $('#'+form_id).find('#image_url').val();
    if (image_url === '') {
      image_url = 'https://'
    }
    var alt_text = $('#'+form_id).find('#alt_text').val();
    var image = '\n\n!['+alt_text+']('+image_url+')\n\n';  // markdown syntax
    if (form_id == "insert_introduction_text_image_form") {
      let pos = introductionMDE.codemirror.getCursor();
      introductionMDE.codemirror.replaceRange(image, pos);
    }
    if (form_id == "insert_after_submit_text_image_form") {
      let pos = afterSubmitMDE.codemirror.getCursor();
      afterSubmitMDE.codemirror.replaceRange(image, pos);
    }
    return false;
  });

  $(document).on("insert_link", function(event, form_id) {
    $('.modal').modal('hide');
    var link_url = $('#'+form_id).find('input[name=link_url]').val();
    if (link_url === '') {
      link_url = 'https://'
    }
    var link_text = $('#'+form_id).find('input[name=link_text]').val();
    if (link_text === '') {
      link_text = link_url
    }
    if (form_id == "insert_introduction_text_link_form") {
      if ($('#introduction_text').find(".CodeMirror-selectedtext").length) {
        introductionMDE.codemirror.replaceSelection('['+link_text+']('+link_url+')');
      } else {
        let pos = introductionMDE.codemirror.getCursor();
        introductionMDE.codemirror.replaceRange(' ['+link_text+']('+link_url+') ', pos);
      }
    }
    if (form_id == "insert_after_submit_text_link_form") {
      if ($('#after_submit_text').find(".CodeMirror-selectedtext").length) {
        afterSubmitMDE.codemirror.replaceSelection('['+link_text+']('+link_url+')');
      } else {
        let pos = afterSubmitMDE.codemirror.getCursor();
        afterSubmitMDE.codemirror.replaceRange(' ['+link_text+']('+link_url+') ', pos);
      }
    }
    return false;
  });
});
</script>

{% endblock %}
